Ginkgo: gko::matrix::Fbcsr< ValueType, IndexType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::matrix::Fbcsr< ValueType, IndexType > Class Template Reference
Linear Operators » SpMV employing different Matrix formats | Linear Operators

Fixed-block compressed sparse row storage matrix format. More...

`#include <ginkgo/core/matrix/fbcsr.hpp>`

Inheritance diagram for gko::matrix::Fbcsr< ValueType, IndexType >:
[legend]
Collaboration diagram for gko::matrix::Fbcsr< ValueType, IndexType >:
[legend]

## Public Types
using | value_type = ValueType
using | index_type = IndexType
using | transposed_type = Fbcsr<ValueType, IndexType>
using | mat_data = matrix_data<ValueType, IndexType>
using | device_mat_data = device_matrix_data<ValueType, IndexType>
using | absolute_type = remove_complex<Fbcsr>
Public Types inherited from gko::EnablePolymorphicAssignment< Fbcsr< default_precision, int32 > >
using | result_type
Public Types inherited from gko::DiagonalExtractable< default_precision >
using | value_type
Public Types inherited from gko::ReadableFromMatrixData< default_precision, int32 >
using | value_type
using | index_type
Public Types inherited from gko::WritableToMatrixData< default_precision, int32 >
using | value_type
using | index_type
Public Types inherited from gko::EnableAbsoluteComputation< remove_complex< Fbcsr< default_precision, int32 > > >
using | absolute_type

## Public Member Functions
void | convert_to (Fbcsr< next_precision< ValueType >, IndexType > *result) const override
void | move_to (Fbcsr< next_precision< ValueType >, IndexType > *result) override
void | convert_to (Dense< ValueType > *other) const override
void | move_to (Dense< ValueType > *other) override
void | convert_to (Csr< ValueType, IndexType > *result) const override
| Converts the matrix to CSR format.
void | move_to (Csr< ValueType, IndexType > *result) override
void | convert_to (SparsityCsr< ValueType, IndexType > *result) const override
| Get the block sparsity pattern in CSR-like format.
void | move_to (SparsityCsr< ValueType, IndexType > *result) override
void | read (const mat_data &data) override
| Reads a matrix_data into Fbcsr format.
void | read (const device_mat_data &data) override
void | read (device_mat_data &&data) override
void | write (mat_data &data) const override
std::unique_ptr< LinOp > | transpose () const override
| Returns a LinOp representing the transpose of the Transposable object.
std::unique_ptr< LinOp > | conj_transpose () const override
| Returns a LinOp representing the conjugate transpose of the Transposable object.
std::unique_ptr< Diagonal< ValueType > > | extract_diagonal () const override
| Extracts the diagonal entries of the matrix into a vector.
std::unique_ptr< absolute_type > | compute_absolute () const override
| Gets the AbsoluteLinOp.
void | compute_absolute_inplace () override
| Compute absolute inplace on each element.
void | sort_by_column_index ()
| Sorts the values blocks and block-column indices in each row by column index.
bool | is_sorted_by_column_index () const
| Tests if all row entry pairs (value, col_idx) are sorted by column index.
value_type * | get_values () noexcept
const value_type * | get_const_values () const noexcept
index_type * | get_col_idxs () noexcept
const index_type * | get_const_col_idxs () const noexcept
index_type * | get_row_ptrs () noexcept
const index_type * | get_const_row_ptrs () const noexcept
size_type | get_num_stored_elements () const noexcept
size_type | get_num_stored_blocks () const noexcept
int | get_block_size () const noexcept
index_type | get_num_block_rows () const noexcept
index_type | get_num_block_cols () const noexcept
Fbcsr & | operator= (const Fbcsr &)
| Copy-assigns an Fbcsr matrix.
Fbcsr & | operator= (Fbcsr &&)
| Move-assigns an Fbcsr matrix.
| Fbcsr (const Fbcsr &)
| Copy-constructs an Ell matrix.
| Fbcsr (Fbcsr &&)
| Move-constructs an Fbcsr matrix.
Public Member Functions inherited from gko::EnableLinOp< Fbcsr< default_precision, int32 > >
const Fbcsr< default_precision, int32 > * | apply (ptr_param< const LinOp > b, ptr_param< LinOp > x) const
Public Member Functions inherited from gko::EnablePolymorphicAssignment< Fbcsr< default_precision, int32 > >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override
Public Member Functions inherited from gko::DiagonalExtractable< default_precision >
std::unique_ptr< LinOp > | extract_diagonal_linop () const override
| Extracts the diagonal entries of the matrix into a vector.
Public Member Functions inherited from gko::ReadableFromMatrixData< default_precision, int32 >
virtual void | read (const matrix_data< default_precision, int32 > &data)=0
| Reads a matrix from a matrix_data structure.
Public Member Functions inherited from gko::WritableToMatrixData< default_precision, int32 >
virtual void | write (matrix_data< default_precision, int32 > &data) const=0
| Writes a matrix to a matrix_data structure.
Public Member Functions inherited from gko::EnableAbsoluteComputation< remove_complex< Fbcsr< default_precision, int32 > > >
std::unique_ptr< LinOp > | compute_absolute_linop () const override
| Gets the absolute LinOp.

## Static Public Member Functions
static std::unique_ptr< Fbcsr > | create (std::shared_ptr< const Executor > exec, int block_size=1)
| Creates an uninitialized FBCSR matrix with the given block size.
static std::unique_ptr< Fbcsr > | create (std::shared_ptr< const Executor > exec, const dim< 2 > &size, size_type num_nonzeros, int block_size)
| Creates an uninitialized FBCSR matrix of the specified size.
static std::unique_ptr< Fbcsr > | create (std::shared_ptr< const Executor > exec, const dim< 2 > &size, int block_size, array< value_type > values, array< index_type > col_idxs, array< index_type > row_ptrs)
| Creates a FBCSR matrix from already allocated (and initialized) row pointer, column index and value arrays.
template<typename InputValueType, typename InputColumnIndexType, typename InputRowPtrType>
static std::unique_ptr< Fbcsr > | create (std::shared_ptr< const Executor > exec, const dim< 2 > &size, int block_size, std::initializer_list< InputValueType > values, std::initializer_list< InputColumnIndexType > col_idxs, std::initializer_list< InputRowPtrType > row_ptrs)
| create(std::shared_ptr<const Executor>,const dim<2>&, int, array<value_type>, array<index_type>,array<index_type>)
static std::unique_ptr< const Fbcsr > | create_const (std::shared_ptr< const Executor > exec, const dim< 2 > &size, int blocksize, gko::detail::const_array_view< ValueType > &&values, gko::detail::const_array_view< IndexType > &&col_idxs, gko::detail::const_array_view< IndexType > &&row_ptrs)
| Creates a constant (immutable) Fbcsr matrix from a constant array.

## Friends
class | EnablePolymorphicObject< Fbcsr, LinOp >
class | Csr< ValueType, IndexType >
class | Dense< ValueType >
class | SparsityCsr< ValueType, IndexType >
class | FbcsrBuilder< ValueType, IndexType >
class | Fbcsr< to_complex< ValueType >, IndexType >
class | Fbcsr< previous_precision< ValueType >, IndexType >

## Detailed Description

template<typename ValueType = default_precision, typename IndexType = int32>
class gko::matrix::Fbcsr< ValueType, IndexType >

Fixed-block compressed sparse row storage matrix format.

FBCSR is a matrix format meant for matrices having a natural block structure made up of small, dense, disjoint blocks. It is similar to CSR

See also
  Csr. However, unlike Csr, each non-zero location stores a small dense block of entries having a constant size. This reduces the number of integers that need to be stored in order to refer to a given non-zero entry, and enables efficient implementation of certain block methods.

The block size is expected to be known in advance and passed to the constructor.

Note
  The total number of rows and the number of columns are expected to be divisible by the block size.

The nonzero elements are stored in a 1D array row-wise, and accompanied with a row pointer array which stores the starting index of each block-row. An additional block-column index array is used to identify the block-column of each nonzero block.

The Fbcsr LinOp supports different operations:

matrix::Fbcsr *A, *B, *C; // matrices
matrix::Dense *b, *x; // vectors tall-and-skinny matrices
matrix::Dense *alpha, *beta; // scalars of dimension 1x1
// Applying to Dense matrices computes an SpMV/SpMM product
A->apply(b, x) // x = A*b
A->apply(alpha, b, beta, x) // x = alpha*A*b + beta*x
gko::matrix::Dense
Dense is a matrix format which explicitly stores all values of the matrix.
Definition dense.hpp:120
gko::matrix::Fbcsr
Fixed-block compressed sparse row storage matrix format.
Definition fbcsr.hpp:116

Template Parameters

  ValueType | precision of matrix elements
  IndexType | precision of matrix indexes

## Constructor & Destructor Documentation

## ◆ Fbcsr() [1/2]

template<typename ValueType = default_precision, typename IndexType = int32>

gko::matrix::Fbcsr< ValueType, IndexType >::Fbcsr | ( | const Fbcsr< ValueType, IndexType > & |  | ) |

Copy-constructs an Ell matrix.

Inherits executor and data.

## ◆ Fbcsr() [2/2]

template<typename ValueType = default_precision, typename IndexType = int32>

gko::matrix::Fbcsr< ValueType, IndexType >::Fbcsr | ( | Fbcsr< ValueType, IndexType > && |  | ) |

Move-constructs an Fbcsr matrix.

Inherits executor and data. The moved-from object is empty (0x0 with no nonzeros, but valid row pointers).

## Member Function Documentation

## ◆ compute_absolute()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< absolute_type > gko::matrix::Fbcsr< ValueType, IndexType >::compute_absolute | ( |  | ) | const
| overridevirtual

Gets the AbsoluteLinOp.

Returns
  a pointer to the new absolute object

Implements gko::EnableAbsoluteComputation< remove_complex< Fbcsr< default_precision, int32 > > >.

## ◆ compute_absolute_inplace()

template<typename ValueType = default_precision, typename IndexType = int32>

void gko::matrix::Fbcsr< ValueType, IndexType >::compute_absolute_inplace | ( |  | ) |
| overridevirtual

Compute absolute inplace on each element.

Implements gko::AbsoluteComputable.

## ◆ conj_transpose()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< LinOp > gko::matrix::Fbcsr< ValueType, IndexType >::conj_transpose | ( |  | ) | const
| overridevirtual

Returns a LinOp representing the conjugate transpose of the Transposable object.

Returns
  a pointer to the new conjugate transposed object

Implements gko::Transposable.

## ◆ convert_to() [1/2]

template<typename ValueType = default_precision, typename IndexType = int32>

void gko::matrix::Fbcsr< ValueType, IndexType >::convert_to | ( | Csr< ValueType, IndexType > * | result | ) | const
| override

Converts the matrix to CSR format.

Note
  Any explicit zeros in the original matrix are retained in the converted result.

## ◆ convert_to() [2/2]

template<typename ValueType = default_precision, typename IndexType = int32>

void gko::matrix::Fbcsr< ValueType, IndexType >::convert_to | ( | SparsityCsr< ValueType, IndexType > * | result | ) | const
| override

Get the block sparsity pattern in CSR-like format.

Note
  The actual non-zero values are never copied; the result always has a value array of size 1 with the value 1.

## ◆ create() [1/4]

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< Fbcsr > gko::matrix::Fbcsr< ValueType, IndexType >::create | ( | std::shared_ptr< const Executor > | exec,
|  | const dim< 2 > & | size,
|  | int | block_size,
|  | array< value_type > | values,
|  | array< index_type > | col_idxs,
|  | array< index_type > | row_ptrs )
| static

Creates a FBCSR matrix from already allocated (and initialized) row pointer, column index and value arrays.

Parameters

  exec | Executor associated to the matrix
  size | size of the matrix
  block_size | Size of the small square dense nonzero blocks
  values | the value array of the matrix, stored in column-major order for each block
  col_idxs | the block column index array of the matrix
  row_ptrs | the block row pointer array of the matrix

Note
  If one of row_ptrs, col_idxs or values is not an rvalue, not an array of IndexType, IndexType and ValueType, respectively, or is on the wrong executor, an internal copy of that array will be created, and the original array data will not be used in the matrix.

Returns
  A smart pointer to the newly created matrix.

## ◆ create() [2/4]

template<typename ValueType = default_precision, typename IndexType = int32>
template<typename InputValueType, typename InputColumnIndexType, typename InputRowPtrType>

std::unique_ptr< Fbcsr > gko::matrix::Fbcsr< ValueType, IndexType >::create | ( | std::shared_ptr< const Executor > | exec,
|  | const dim< 2 > & | size,
|  | int | block_size,
|  | std::initializer_list< InputValueType > | values,
|  | std::initializer_list< InputColumnIndexType > | col_idxs,
|  | std::initializer_list< InputRowPtrType > | row_ptrs )
| inlinestatic

create(std::shared_ptr<const Executor>,const dim<2>&, int, array<value_type>, array<index_type>,array<index_type>)

create(std::shared_ptr<const Executor>,const dim<2>&, int, array<value_type>, array<index_type>,array<index_type>)

## ◆ create() [3/4]

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< Fbcsr > gko::matrix::Fbcsr< ValueType, IndexType >::create | ( | std::shared_ptr< const Executor > | exec,
|  | const dim< 2 > & | size,
|  | size_type | num_nonzeros,
|  | int | block_size )
| static

Creates an uninitialized FBCSR matrix of the specified size.

Parameters

  exec | Executor associated to the matrix
  size | size of the matrix
  num_nonzeros | number of stored nonzeros. It needs to be a multiple of block_size * block_size.
  block_size | size of the small dense square blocks

Returns
  A smart pointer to the newly created matrix.

## ◆ create() [4/4]

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< Fbcsr > gko::matrix::Fbcsr< ValueType, IndexType >::create | ( | std::shared_ptr< const Executor > | exec,
|  | int | block_size = 1 )
| static

Creates an uninitialized FBCSR matrix with the given block size.

Parameters

  exec | Executor associated to the matrix
  block_size | The desired size of the dense square nonzero blocks; defaults to 1.

Returns
  A smart pointer to the newly created matrix.

Referenced by create().

## ◆ create_const()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< const Fbcsr > gko::matrix::Fbcsr< ValueType, IndexType >::create_const | ( | std::shared_ptr< const Executor > | exec,
|  | const dim< 2 > & | size,
|  | int | blocksize,
|  | gko::detail::const_array_view< ValueType > && | values,
|  | gko::detail::const_array_view< IndexType > && | col_idxs,
|  | gko::detail::const_array_view< IndexType > && | row_ptrs )
| static

Creates a constant (immutable) Fbcsr matrix from a constant array.

Parameters

  exec | the executor to create the matrix on
  size | the dimensions of the matrix
  blocksize | the block size of the matrix
  values | the value array of the matrix, stored in column-major order for each block
  col_idxs | the block column index array of the matrix
  row_ptrs | the block row pointer array of the matrix

Returns
  A smart pointer to the constant matrix wrapping the input arrays (if they reside on the same executor as the matrix) or a copy of the arrays on the correct executor.

## ◆ extract_diagonal()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< Diagonal< ValueType > > gko::matrix::Fbcsr< ValueType, IndexType >::extract_diagonal | ( |  | ) | const
| overridevirtual

Extracts the diagonal entries of the matrix into a vector.

Parameters

  diag | the vector into which the diagonal will be written

Implements gko::DiagonalExtractable< default_precision >.

## ◆ get_block_size()

template<typename ValueType = default_precision, typename IndexType = int32>

int gko::matrix::Fbcsr< ValueType, IndexType >::get_block_size | ( |  | ) | const
| inlinenoexcept

Returns
  The fixed block size for this matrix

## ◆ get_col_idxs()

template<typename ValueType = default_precision, typename IndexType = int32>

index_type * gko::matrix::Fbcsr< ValueType, IndexType >::get_col_idxs | ( |  | ) |
| inlinenoexcept

Returns
  The column indexes of the matrix.

## ◆ get_const_col_idxs()

template<typename ValueType = default_precision, typename IndexType = int32>

const index_type * gko::matrix::Fbcsr< ValueType, IndexType >::get_const_col_idxs | ( |  | ) | const
| inlinenoexcept

Returns
  The column indexes of the matrix.

Note
  This is the constant version of the function, which can be significantly more memory efficient than the non-constant version, so always prefer this version.

## ◆ get_const_row_ptrs()

template<typename ValueType = default_precision, typename IndexType = int32>

const index_type * gko::matrix::Fbcsr< ValueType, IndexType >::get_const_row_ptrs | ( |  | ) | const
| inlinenoexcept

Returns
  The row pointers of the matrix.

Note
  This is the constant version of the function, which can be significantly more memory efficient than the non-constant version, so always prefer this version.

## ◆ get_const_values()

template<typename ValueType = default_precision, typename IndexType = int32>

const value_type * gko::matrix::Fbcsr< ValueType, IndexType >::get_const_values | ( |  | ) | const
| inlinenoexcept

Returns
  The values of the matrix.

Note
  This is the constant version of the function, which can be significantly more memory efficient than the non-constant version, so always prefer this version.

## ◆ get_num_block_cols()

template<typename ValueType = default_precision, typename IndexType = int32>

index_type gko::matrix::Fbcsr< ValueType, IndexType >::get_num_block_cols | ( |  | ) | const
| inlinenoexcept

Returns
  The number of block-columns in the matrix

## ◆ get_num_block_rows()

template<typename ValueType = default_precision, typename IndexType = int32>

index_type gko::matrix::Fbcsr< ValueType, IndexType >::get_num_block_rows | ( |  | ) | const
| inlinenoexcept

Returns
  The number of block-rows in the matrix

## ◆ get_num_stored_blocks()

template<typename ValueType = default_precision, typename IndexType = int32>

size_type gko::matrix::Fbcsr< ValueType, IndexType >::get_num_stored_blocks | ( |  | ) | const
| inlinenoexcept

Returns
  The number of non-zero blocks explicitly stored in the matrix

## ◆ get_num_stored_elements()

template<typename ValueType = default_precision, typename IndexType = int32>

size_type gko::matrix::Fbcsr< ValueType, IndexType >::get_num_stored_elements | ( |  | ) | const
| inlinenoexcept

Returns
  The number of elements explicitly stored in the matrix

## ◆ get_row_ptrs()

template<typename ValueType = default_precision, typename IndexType = int32>

index_type * gko::matrix::Fbcsr< ValueType, IndexType >::get_row_ptrs | ( |  | ) |
| inlinenoexcept

Returns
  The row pointers of the matrix.

## ◆ get_values()

template<typename ValueType = default_precision, typename IndexType = int32>

value_type * gko::matrix::Fbcsr< ValueType, IndexType >::get_values | ( |  | ) |
| inlinenoexcept

Returns
  The values of the matrix.

## ◆ is_sorted_by_column_index()

template<typename ValueType = default_precision, typename IndexType = int32>

bool gko::matrix::Fbcsr< ValueType, IndexType >::is_sorted_by_column_index | ( |  | ) | const

Tests if all row entry pairs (value, col_idx) are sorted by column index.

Returns
  True if all row entry pairs (value, col_idx) are sorted by column index

## ◆ operator=() [1/2]

template<typename ValueType = default_precision, typename IndexType = int32>

Fbcsr & gko::matrix::Fbcsr< ValueType, IndexType >::operator= | ( | const Fbcsr< ValueType, IndexType > & |  | ) |

Copy-assigns an Fbcsr matrix.

Preserves the executor, copies data and block size from the input.

## ◆ operator=() [2/2]

template<typename ValueType = default_precision, typename IndexType = int32>

Fbcsr & gko::matrix::Fbcsr< ValueType, IndexType >::operator= | ( | Fbcsr< ValueType, IndexType > && |  | ) |

Move-assigns an Fbcsr matrix.

Preserves the executor, moves the data over preserving size and stride. Leaves the moved-from object in an empty state (0x0 with no nonzeros, but valid row pointers).

## ◆ read()

template<typename ValueType = default_precision, typename IndexType = int32>

void gko::matrix::Fbcsr< ValueType, IndexType >::read | ( | const mat_data & | data | ) |
| override

Reads a matrix_data into Fbcsr format.

Requires the block size to be set beforehand

See also
  set_block_size.

Warning
  Unlike Csr::read, here explicit non-zeros are NOT dropped.

## ◆ transpose()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< LinOp > gko::matrix::Fbcsr< ValueType, IndexType >::transpose | ( |  | ) | const
| overridevirtual

Returns a LinOp representing the transpose of the Transposable object.

Returns
  a pointer to the new transposed object

Implements gko::Transposable.

The documentation for this class was generated from the following files:

- ginkgo/core/matrix/csr.hpp
- ginkgo/core/matrix/fbcsr.hpp